function [f,g,state] = fqd(um, par, subs, xinit)
nx=par(1); nu=par(2); nn=par(3);b=par(6);
% compute state function
pd=char(subs(1));
xm=zeros(nn+1,nx); xm(1,:)=xinit;
for tc=1:nn
   ff=feval(pd,tc,um,xm,par);
   xm(tc+1,:) = xm(tc,:) + ff;
end
% compute objective function
jf=0; pd=char(subs(2));
for tc=1:nn
   ff=feval(pd,tc,um,xm,par);
   jf=jf+ff;
end
pd=char(subs(3));
jf=jf+feval(pd,tc,um,xm,par);
% compute constraint on control
pd=char(subs(4));
for tc=1:nn
   g(tc)=feval(pd,tc,um,xm,par);
end
f=jf;
state=xm;
